
;Display 16 bit registers and flags - DednDave

        .MODEL  SMALL
        .STACK  512

;----------------------------------------------------------------------------------------------

        .DATA

Show_Rs db 'AX='
R_AX    db 4 dup(?),32,32
        db 'BX='
R_BX    db 4 dup(?),32,32
        db 'CX='
R_CX    db 4 dup(?),32,32
        db 'DX='
R_DX    db 4 dup(?),32,32
        db 'DS='
R_DS    db 4 dup(?),32,32
        db 'SI='
R_SI    db 4 dup(?),32,32
        db 'ES='
R_ES    db 4 dup(?),32,32
        db 'DI='
R_DI    db 4 dup(?),0

Show_Fs db 'CS='
R_CS    db 4 dup('x'),32,32
        db 'IP='
R_IP    db 4 dup('x'),32,32
        db 'BP='
R_BP    db 4 dup('x'),32,32
        db 'SS='
R_SS    db 4 dup('x'),32,32
        db 'SP='
R_SP    db 4 dup('x'),32

F_OF    db 'NV '                     ;NV/OV 0800h overflow
F_DF    db 'UP '                     ;UP/DN 0400h direction
F_IF    db 'DI '                     ;DI/EI 0200h interrupt enable
F_TF    db 'NT '                     ;NT/SS 0100h trap/single step
F_SF    db 'PL '                     ;PL/NG 0080h sign
F_ZF    db 'NZ '                     ;NZ/ZR 0040h zero
F_AF    db 'NA '                     ;NA/AC 0010h auxiliary carry
F_PF    db 'PO '                     ;PO/PE 0004h parity
F_CF    db 'NC',0                    ;NC/CY 0001h carry

Prmpt   db 'Press Any Key to Exit',0

;----------------------------------------------------------------------------------------------

        .CODE

_main   PROC    FAR

        call far ptr SRegs           ;must be a CALL FAR instruction (not PUSH CS, CALL NEAR)

        mov     ax,3
        int     10h

        mov     ax,@DATA
        mov     ds,ax

        cld

        mov     ah,7
        mov     si,offset Show_Rs
        mov     di,0*2*80
        call    Dsply
        mov     di,1*2*80
        call    Dsply
        mov     di,3*2*80
        call    Dsply

        mov     dx,4*100h
        mov     bh,0
        mov     ah,2
        int     10h
        mov     ah,0
        int     16h

        mov     ax,4C00h
        int     21h

_main   ENDP

;----------------------------------------------------------------------------------------------

Dsply   PROC    NEAR

;DS:SI = pointer to null-terminated string
;   DI = video buffer offset
;   DF = clear (up)

        push    es
        push    ax
        mov     ax,0B800h
        mov     es,ax
        pop     ax
        jmp short Dsply1

Dsply0: stosw

Dsply1: lodsb
        or      al,al
        jnz     Dsply0

        pop     es
        ret

Dsply   ENDP

;----------------------------------------------------------------------------------------------

B2Hex   PROC    NEAR

;   DX = 16 bit value to convert
;ES:DI = pointer to 4 byte string space

        mov     cx,4
        add     di,cx

B2Hex0: mov     al,dl
        and     al,0Fh
        dec     di
        add     al,90h
        daa
        adc     al,40h
        daa
        mov     es:[di],al
        shr     dx,1
        shr     dx,1
        shr     dx,1
        shr     dx,1
        loop    B2Hex0

        ret

B2Hex   ENDP

;----------------------------------------------------------------------------------------------

HLoop   PROC    NEAR

;DS:SI = stack address of saved registers
;ES:DI = pointer to display strings
;   CX = loop count

HLoop0: mov     dx,[si]
        push    cx
        call    B2Hex
        pop     cx
        add     si,2
        add     di,9
        loop    HLoop0

        ret

HLoop   ENDP

;----------------------------------------------------------------------------------------------

FlVal   PROC    NEAR

;   AX = text for flag if set
;   CX = test mask
;   DX = saved flags value
;ES:DI = pointer to display string

        test    dx,cx
        jz      FlVal0

        mov     es:[di],ax

FlVal0: add     di,3
        ret

FlVal   ENDP

;----------------------------------------------------------------------------------------------

SRegs   PROC    FAR

Val_CS  TEXTEQU <[BP+24]>
Val_IP  TEXTEQU <[BP+22]>
Val_DI  TEXTEQU <[BP+20]>
Val_ES  TEXTEQU <[BP+18]>
Val_SI  TEXTEQU <[BP+16]>
Val_DS  TEXTEQU <[BP+14]>
Val_DX  TEXTEQU <[BP+12]>
Val_CX  TEXTEQU <[BP+10]>
Val_BX  TEXTEQU <[BP+8]>
Val_AX  TEXTEQU <[BP+6]>
Val_FL  TEXTEQU <[BP+4]>
Val_SS  TEXTEQU <[BP+2]>
Val_BP  TEXTEQU <[BP]>

        push    di
        push    es
        push    si
        push    ds
        push    dx
        push    cx
        push    bx
        push    ax
        pushf
        push    ss
        push    bp
        mov     bp,sp

        cld
        push    ss
        pop     ds
        mov     ax,@DATA
        mov     es,ax

        lea     si,Val_AX
        mov     di,offset R_AX
        mov     cx,8
        call    HLoop

        lea     si,Val_BP
        mov     di,offset R_BP
        mov     cl,2
        call    HLoop

        lea     dx,Val_CS
        add     dx,2                 ;original SP value = Val_CS + 2
        call    B2Hex

        mov     dx,Val_CS
        mov     di,offset R_CS
        call    B2Hex

        mov     dx,Val_IP
        sub     dx,5                 ;adjust IP for the FAR CALL instruction
        mov     di,offset R_IP
        call    B2Hex

        mov     di,offset F_OF       ;do the flags
        mov     dx,Val_FL

        mov     cx,800h
        mov     ax,'VO'
        call    FlVal

        mov     ch,4
        mov     ax,'ND'
        call    FlVal

        mov     ch,2
        mov     ax,'IE'
        call    FlVal

        mov     ch,1
        mov     ax,'SS'
        call    FlVal

        shr     cx,1
        mov     ax,'GN'
        call    FlVal

        mov     cl,40h
        mov     ax,'RZ'
        call    FlVal

        mov     cl,10h
        mov     ax,'CA'
        call    FlVal

        mov     cl,4
        mov     ax,'EP'
        call    FlVal

        mov     cl,1
        mov     ax,'YC'
        call    FlVal

        pop     bp
        add     sp,2                 ;discard the saved SS value
        popf
        pop     ax
        pop     bx
        pop     cx
        pop     dx
        pop     ds
        pop     si
        pop     es
        pop     di
        ret

SRegs   ENDP

;----------------------------------------------------------------------------------------------

        END     _main


